unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private 錾 }
    fBitmap: TBitmap;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Flog;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
    i: integer;
    aFlog: TFlog;
begin

    for i := 0 to 10 do begin
        aFlog := TFlog.Create;
    end;
    aFlog.mResetAll;
    aFlog.mDrawFlogs;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin

    if Timer1.Interval > 0 then Timer1.Interval := 0
    else                        Timer1.Interval := 50;

end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    i: integer;
    str: string;
begin

    with fBitmap.Canvas do begin
        Brush.Color := clWhite;
        FillRect(Bounds(0, 0, Width, Height));

        str := IntToStr(GetTotal);
        TextOut((PaintBox1.Width - TextWidth(str)) div 2, (PaintBox1.Height - TextHeight(str)) div 2, str);

        i := 0;
        Pen.Color := clGray;
        while i < PaintBox1.Height do begin
            Rectangle(0, i, PaintBox1.Width, i + 1);
            Inc(i, 5);
        end;

        i := 1;
        Pen.Color := clWhite;
        while i < PaintBox1.Height do begin
            Rectangle(0, i, PaintBox1.Width, i + 1);
            Inc(i, 5);
        end;

        Pen.Color := clBlack;

    end;

    MoveFlogs;
    DrawFlogs;

    PaintBox1.Canvas.Draw(0, 0, fBitmap);

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
    PaintBox1.Refresh;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
    aFlog: TFlog;
begin
    fBitmap := TBitmap.Create;
    fBitmap.Width := Screen.Width;
    fBitmap.Height := Screen.Height;
    fBitmap.Canvas.Font := Font;
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csopaque];

    aFlog := TFlog.Create;
    aFlog.mSetCanvas(fBitmap.Canvas);
    aFlog.mResetAll;
    aFlog.mDrawFlogs;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    fBitmap.Free;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    aFlog: TFlog;
begin
    aFlog := TFlog.Create;
    aFlog.mReset(0);
    aFlog.fPosX := X;
    aFlog.fPosY := Y;
    aFlog.mDrawFlogs;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
    fDrawConnection := CheckBox1.Checked;
end;

end.
